#include "sys.h"

//ƫƵַ
//NVIC_VectTab:ַ
//Offset:ƫ
void MY_NVIC_SetVectorTable(u32 NVIC_VectTab, u32 Offset){ 
	SCB->VTOR = NVIC_VectTab|(Offset & (u32)0x1FFFFF80);//NVICƫƼĴ,ڱʶCODERAM
}

void MYRCC_DeInit(){
	RCC->APB1RSTR=0x00000000;//λ
	RCC->APB2RSTR=0x00000000;
	RCC->AHBENR=0x00000014;//˯ģʽSRAMʱʹ,ر
	RCC->APB1ENR=0x00000000;//ʱӹر
	RCC->APB2ENR=0x00000000;
	RCC->CR|=0x00000001;//ʹڲʱHSION
	RCC->CFGR&=0xF8FF0000;//λSW[1:0],HPRE[3:0],PPRE1[2:0],PPRE2[2:0],ADCPRE[1:0],MCO[2:0]
	RCC->CR&=0xFEF6FFFF;//λHSEON,CSSON,PLLON
	RCC->CR&=0xFFFBFFFF;//λHSEBYP
	RCC->CFGR&=0xFF80FFFF;//λPLLSRC, PLLXTPRE, PLLMUL[3:0] and USBPRE
	RCC->CIR=0x00000000;//رж
#ifdef  VECT_TAB_RAM
	MY_NVIC_SetVectorTable(NVIC_VectTab_RAM, 0x0);
#else   
	MY_NVIC_SetVectorTable(NVIC_VectTab_FLASH, 0x0);
#endif
}

//ϵͳʱӳʼ
//pll:ѡıƵ2ʼֵΪ16	
void Stm32_Clock_Init(u8 PLL){
	unsigned char temp=0;
	MYRCC_DeInit();//λ
	RCC->CR|=0x00010000;//ⲿʱʹHSEON
	while(!(RCC->CR>>17));//ȴⲿʱӾ
	RCC->CFGR=0x00000400;//APB1=DIV2;APB2=DIV1;AHB=DIV1
	PLL-=2;//2λ
	RCC->CFGR|=PLL<<18;//PLLֵ 2~16
	RCC->CFGR|=1<<16;//PLLSRC ON
	FLASH->ACR|=0x32;//FLASH 2ʱ
	RCC->CR|=0x01000000;//PLLON
	while(!(RCC->CR>>25));//ȴPLL
	RCC->CFGR|=0x00000002;//PLLΪϵͳʱ
	while(temp!=0x02){//ȴPLLΪϵͳʱóɹ
		temp=RCC->CFGR>>2;
		temp&=0x03;
	}
}

void NVIC_Config(u8 GPIOx,u8 BITx,u8 TRIM){
	u8 EXTIADDR=BITx/4;
	u8 EXTIOFFSET=(BITx%4)*4;
	RCC->APB2ENR|=0x00000001;
	AFIO->EXTICR[EXTIADDR]&=~(0x000F<<EXTIOFFSET);
	AFIO->EXTICR[EXTIADDR]|=GPIOx<<EXTIOFFSET;
	EXTI->IMR|=1<<BITx;
	if(TRIM&0x01)
		EXTI->FTSR|=1<<BITx;
	if(TRIM&0x02)
		EXTI->RTSR|=1<<BITx;
}

void PriorityGroup_Config(u8 NVIC_Group){
	SCB->AIRCR&=0x0000F8FF;
	SCB->AIRCR|=0x05FA0000;
	SCB->AIRCR|=((~NVIC_Group)&0x07)<<8;
}

void Priority_Config(u8 NVIC_PreemptionPriority,u8 NVIC_SubPriority,u8 NVIC_Channel,u8 NVIC_Group){
	NVIC->ISER[NVIC_Channel/32]|=1<<(NVIC_Channel%32);
	NVIC->IPR[NVIC_Channel/4]=(((NVIC_PreemptionPriority<<(4-NVIC_Group))|(NVIC_SubPriority&(0x0F>>NVIC_Group)))&0x0000000F)<<((NVIC_Channel%4)*8+4);
}
