#ifndef __1602_H
#define __1602_H

#include<stm32f10x_lib.h>

#define RSL GPIOC->ODR&=~(1<<0)
#define RSH GPIOC->ODR|=1<<0
#define RWW GPIOC->ODR&=~(1<<1)
#define RWR GPIOC->ODR|=1<<1
#define NEN GPIOC->ODR&=~(1<<2)
#define EN GPIOC->ODR|=1<<2

#define SEND(x) {GPIOE->ODR&=0xFFFFFF00; GPIOE->ODR|=x;}

void Output_Config(void);
void L1602_GPIO_Init(void);
void WriteCmd(u8 cmd);
void WriteData(u8 data);
void L1602_Init(void);

#endif
